#include <windows.h>
#include "netribaasi.h"

extern int mode;

void initgame(game_t* game) {
	memset(game->banmen,0,sizeof(game->banmen));
	game->nowturn=0;
	game->banmen[3][3]=2;
	game->banmen[3][4]=1;
	game->banmen[4][3]=1;
	game->banmen[4][4]=2;
	game->lastx=0xff;
	game->lasty=0xff;
	game->onepass=0;
	game->twopass=0;
}

void drawboard(HDC hdc,const game_t* game,int starttime) {
	HBRUSH hgreenbrush;
	HPEN hredpen;
	HPEN holdpen;
	HBRUSH holdbrush;
	HPEN hyellowpen;
	RECT rc;
	int x,y;
	int nowtime;
	int white=0;
	int black=0;
	char mozibuf[1025];
	/*wihԂ*/
	rc.top=0;
	rc.left=0;
	rc.bottom=480;
	rc.right=640;
	FillRect(hdc,&rc,GetStockObject(WHITE_BRUSH));
	/*Ֆʂ`*/
	/*Ֆʂ̔wi*/
	hgreenbrush=CreateSolidBrush(RGB(0,255,0));
	rc.top=20;
	rc.left=20;
	rc.bottom=420;
	rc.right=420;
	FillRect(hdc,&rc,hgreenbrush);
	/*Ֆʂ̐*/
	holdpen=SelectObject(hdc,GetStockObject(BLACK_PEN));
	for(x=20;x<=420;x+=50) {
		MoveToEx(hdc,x,20,NULL);
		LineTo(hdc,x,421);
		MoveToEx(hdc,20,x,NULL);
		LineTo(hdc,421,x);
	}
	/*R}*/
	holdbrush=SelectObject(hdc,GetStockObject(BLACK_BRUSH));
	nowtime=GetTickCount()-starttime;
	for(y=0;y<8;y++) {
		for(x=0;x<8;x++) {
			/*uĂR}*/
			if(game->banmen[x][y] & 4 && nowtime<1000) {
				if(nowtime<500) {
					if((game->banmen[x][y]&3)==1) {
						SelectObject(hdc,GetStockObject(BLACK_PEN));
						SelectObject(hdc,GetStockObject(WHITE_BRUSH));
						Ellipse(hdc,20+x*50+5+(nowtime*20/500),20+y*50+5,
							20+x*50+45-(nowtime*20/500),20+y*50+45);
					} else if((game->banmen[x][y]&3)==2) {
						SelectObject(hdc,GetStockObject(WHITE_PEN));
						SelectObject(hdc,GetStockObject(BLACK_BRUSH));
						Ellipse(hdc,20+x*50+5+(nowtime*20/500),20+y*50+5,
							20+x*50+45-(nowtime*20/500),20+y*50+45);
					}
				} else {
					if((game->banmen[x][y]&3)==1) {
						SelectObject(hdc,GetStockObject(WHITE_PEN));
						SelectObject(hdc,GetStockObject(BLACK_BRUSH));
						Ellipse(hdc,20+x*50+45-(nowtime*20/500),20+y*50+5,
							20+x*50+5+(nowtime*20/500),20+y*50+45);
					} else if((game->banmen[x][y]&3)==2) {
						SelectObject(hdc,GetStockObject(BLACK_PEN));
						SelectObject(hdc,GetStockObject(WHITE_BRUSH));
						Ellipse(hdc,20+x*50+45-(nowtime*20/500),20+y*50+5,
							20+x*50+5+(nowtime*20/500),20+y*50+45);
					}
				}
			} else {
				if((game->banmen[x][y]&3)==1) {
					SelectObject(hdc,GetStockObject(WHITE_PEN));
					SelectObject(hdc,GetStockObject(BLACK_BRUSH));
					Ellipse(hdc,20+x*50+5,20+y*50+5,20+x*50+45,20+y*50+45);
				} else if((game->banmen[x][y]&3)==2) {
					SelectObject(hdc,GetStockObject(BLACK_PEN));
					SelectObject(hdc,GetStockObject(WHITE_BRUSH));
					Ellipse(hdc,20+x*50+5,20+y*50+5,20+x*50+45,20+y*50+45);
				}
			}
			/*uƂ*/
			if(canput(game,x,y,game->nowturn)) {
				SelectObject(hdc,GetStockObject(NULL_BRUSH));
				if(game->nowturn)SelectObject(hdc,GetStockObject(WHITE_PEN));
				else SelectObject(hdc,GetStockObject(BLACK_PEN));
				Ellipse(hdc,20+x*50+5,20+y*50+5,20+x*50+45,20+y*50+45);
			}
			/*𐔂*/
			if((game->banmen[x][y]&3)==1)black++;
			if((game->banmen[x][y]&3)==2)white++;
		}
	}
	/*ŌɒuƂ*/
	hyellowpen=CreatePen(PS_SOLID,1,RGB(255,255,0)); 
	if(game->lastx!=-1 && game->lasty!=-1) {
		SelectObject(hdc,hyellowpen);
		MoveToEx(hdc,20+game->lastx*50+2,20+game->lasty*50+2,NULL);
		LineTo(hdc,20+game->lastx*50+2,20+game->lasty*50+48);
		LineTo(hdc,20+game->lastx*50+48,20+game->lasty*50+48);
		LineTo(hdc,20+game->lastx*50+48,20+game->lasty*50+2);
		LineTo(hdc,20+game->lastx*50+2,20+game->lasty*50+2);
	}
	/*Ȅ*/
	hredpen=CreatePen(PS_SOLID,1,RGB(255,0,0));
	/*g*/
	if(game->nowturn)SelectObject(hdc,GetStockObject(BLACK_PEN));
	else SelectObject(hdc,hredpen);
	SelectObject(hdc,GetStockObject(NULL_BRUSH));
	Rectangle(hdc,430,20,630,160);
	if(!game->nowturn)SelectObject(hdc,GetStockObject(BLACK_PEN));
	else SelectObject(hdc,hredpen);
	Rectangle(hdc,430,190,630,330);
	/**/
	if(mode==MODE_SERVER) {
		TextOut(hdc,470,40,"",4);
		TextOut(hdc,470,210,"",4);
	} else if(mode==MODE_CLIENT) {
		TextOut(hdc,470,40,"",4);
		TextOut(hdc,470,210,"",4);
	}
	SelectObject(hdc,GetStockObject(WHITE_PEN));
	SelectObject(hdc,GetStockObject(BLACK_BRUSH));
	Ellipse(hdc,435,40,465,70);
	SelectObject(hdc,GetStockObject(BLACK_PEN));
	SelectObject(hdc,GetStockObject(WHITE_BRUSH));
	Ellipse(hdc,435,210,465,240);
	TextOut(hdc,470,70,game->onename,lstrlen(game->onename));
	TextOut(hdc,470,240,game->twoname,lstrlen(game->twoname));
	wsprintf(mozibuf,"%2d",black);
	TextOut(hdc,470,100,mozibuf,lstrlen(mozibuf));
	wsprintf(mozibuf,"%2d",white);
	TextOut(hdc,470,270,mozibuf,lstrlen(mozibuf));
	if(game->onepass && !game->twopass && game->lastput)
		TextOut(hdc,470,130,"pX",4);
	if(game->twopass && !game->onepass && !game->lastput)
		TextOut(hdc,470,300,"pX",4);
	/*s*/
	if(game->onepass && game->twopass) {
		if(black>white)wsprintf(mozibuf,"i%sj̏łB",game->onename); 
		else if(black<white)wsprintf(mozibuf,"i%sj̏łB",game->twoname); 
		else wsprintf(mozibuf,"łB");
		TextOut(hdc,50,430,mozibuf,lstrlen(mozibuf));
		TextOut(hdc,50,455,"EscōăQ[",13);
	}
	wsprintf(mozibuf,"%2dlϐ풆",ntohl(game->kansennum));
	TextOut(hdc,430,350,mozibuf,lstrlen(mozibuf));
	TextOut(hdc,430,370,game->clientname[0],lstrlen(game->clientname[0]));
	TextOut(hdc,430,390,game->clientname[1],lstrlen(game->clientname[1]));
	TextOut(hdc,430,410,game->clientname[2],lstrlen(game->clientname[2]));
	TextOut(hdc,430,430,game->clientname[3],lstrlen(game->clientname[3]));
	TextOut(hdc,430,450,game->clientname[4],lstrlen(game->clientname[4]));
	/*J*/
	SelectObject(hdc,holdpen);
	SelectObject(hdc,holdbrush);
	DeleteObject(hgreenbrush);
	DeleteObject(hyellowpen);
	DeleteObject(hredpen);
}

#define CANPUT_LEFT			1
#define CANPUT_LEFTUP		2
#define CANPUT_UP			4
#define CANPUT_RIGHTUP		8
#define CANPUT_RIGHT		16
#define CANPUT_RIGHTDOWN	32
#define CANPUT_DOWN			64
#define CANPUT_LEFTDOWN		128

int canput(const game_t* game,int x,int y,int which) {
	int result=0;
	int xx,yy;
	int iro,haniro;
	iro=(which?2:1);
	haniro=(which?1:2);
	/*ɒuĂƂɂ͒uȂ*/
	if(game->banmen[x][y])return 0;
	/**/
	if(x>1 && (game->banmen[x-1][y]&3)==haniro) {
		for(xx=x-2;xx>=0;xx--) {
			if((game->banmen[xx][y]&3)==0)break;
			if((game->banmen[xx][y]&3)==iro) {
				result|=CANPUT_LEFT;
				break;
			}
		}
	}
	/**/
	if(x>1 && y>1 && (game->banmen[x-1][y-1]&3)==haniro) {
		for(xx=x-2,yy=y-2;xx>=0 && yy>=0;xx--,yy--) {
			if((game->banmen[xx][yy]&3)==0)break;
			if((game->banmen[xx][yy]&3)==iro) {
				result|=CANPUT_LEFTUP;
				break;
			}
		}
	}
	/**/
	if(y>1 && (game->banmen[x][y-1]&3)==haniro) {
		for(yy=y-2;yy>=0;yy--) {
			if((game->banmen[x][yy]&3)==0)break;
			if((game->banmen[x][yy]&3)==iro) {
				result|=CANPUT_UP;
				break;
			}
		}
	}
	/*E*/
	if(x<6 && y>1 && (game->banmen[x+1][y-1]&3)==haniro) {
		for(xx=x+2,yy=y-2;xx<8 && yy>=0;xx++,yy--) {
			if((game->banmen[xx][yy]&3)==0)break;
			if((game->banmen[xx][yy]&3)==iro) {
				result|=CANPUT_RIGHTUP;
				break;
			}
		}
	}
	/*E*/
	if(x<6 && (game->banmen[x+1][y]&3)==haniro) {
		for(xx=x+2;xx<8;xx++) {
			if((game->banmen[xx][y]&3)==0)break;
			if((game->banmen[xx][y]&3)==iro) {
				result|=CANPUT_RIGHT;
				break;
			}
		}
	}
	/*E*/
	if(x<6 && y<6 && (game->banmen[x+1][y+1]&3)==haniro) {
		for(xx=x+2,yy=y+2;xx<8 && yy<8;xx++,yy++) {
			if((game->banmen[xx][yy]&3)==0)break;
			if((game->banmen[xx][yy]&3)==iro) {
				result|=CANPUT_RIGHTDOWN;
				break;
			}
		}
	}
	/**/
	if(y<6 && (game->banmen[x][y+1]&3)==haniro) {
		for(yy=y+2;yy<8;yy++) {
			if((game->banmen[x][yy]&3)==0)break;
			if((game->banmen[x][yy]&3)==iro) {
				result|=CANPUT_DOWN;
				break;
			}
		}
	}
	/**/
	if(x>1 && y<6 && (game->banmen[x-1][y+1]&3)==haniro) {
		for(xx=x-2,yy=y+2;xx>=0 && yy<8;xx--,yy++) {
			if((game->banmen[xx][yy]&3)==0)break;
			if((game->banmen[xx][yy]&3)==iro) {
				result|=CANPUT_LEFTDOWN;
				break;
			}
		}
	}
	return result;
}

int putkoma(game_t* game,int x,int y,int which) {
	int xx,yy;
	int canputno;
	int iro;
	/*u邩*/
	canputno=canput(game,x,y,which);
	if(!canputno)return 0;
	/*uꂽtO܂*/
	for(yy=0;yy<8;yy++) {
		for(xx=0;xx<8;xx++) {
			game->banmen[xx][yy]&=~4;
		}
	}
	/*R}u*/
	iro=(which?2:1);
	/**/
	if(canputno & CANPUT_LEFT) {
		for(xx=x-1;xx>=0;xx--) {
			if((game->banmen[xx][y]&3)==iro)break;
			game->banmen[xx][y]=iro|4;
		}
	}
	/**/
	if(canputno & CANPUT_LEFTUP) {
		for(xx=x-1,yy=y-1;xx>=0 && yy>=0;xx--,yy--) {
			if((game->banmen[xx][yy]&3)==iro)break;
			game->banmen[xx][yy]=iro|4;
		}
	}
	/**/
	if(canputno & CANPUT_UP) {
		for(yy=y-1;yy>=0;yy--) {
			if((game->banmen[x][yy]&3)==iro)break;
			game->banmen[x][yy]=iro|4;
		}
	}
	/*E*/
	if(canputno & CANPUT_RIGHTUP) {
		for(xx=x+1,yy=y-1;xx<8 && yy>=0;xx++,yy--) {
			if((game->banmen[xx][yy]&3)==iro)break;
			game->banmen[xx][yy]=iro|4;
		}
	}
	/*E*/
	if(canputno & CANPUT_RIGHT) {
		for(xx=x+1;xx<8;xx++) {
			if((game->banmen[xx][y]&3)==iro)break;
			game->banmen[xx][y]=iro|4;
		}
	}
	/*E*/
	if(canputno & CANPUT_RIGHTDOWN) {
		for(xx=x+1,yy=y+1;xx<8 && yy<8;xx++,yy++) {
			if((game->banmen[xx][yy]&3)==iro)break;
			game->banmen[xx][yy]=iro|4;
		}
	}
	/**/
	if(canputno & CANPUT_DOWN) {
		for(yy=y+1;yy<8;yy++) {
			if((game->banmen[x][yy]&3)==iro)break;
			game->banmen[x][yy]=iro|4;
		}
	}
	/**/
	if(canputno & CANPUT_LEFTDOWN) {
		for(xx=x-1,yy=y+1;xx>=0 && yy<8;xx--,yy++) {
			if((game->banmen[xx][yy]&3)==iro)break;
			game->banmen[xx][yy]=iro|4;
		}
	}
	/*uꏊ*/
	game->banmen[x][y]=iro;
	game->lastput=which;
	return 1;
}

int ispass(const game_t* game,int which) {
	int x,y;
	for(y=0;y<8;y++) {
		for(x=0;x<8;x++) {
			if(canput(game,x,y,which))return 0;
		}
	}
	return 1;
}

int countkoma(const game_t* game,int which) {
	int x,y;
	int result=0;
	for(y=0;y<8;y++) {
		for(x=0;x<8;x++) {
			if((which && (game->banmen[x][y]&3)==2) ||
				(!which && (game->banmen[x][y]&3)==1))result++;
		}
	}
	return result;
}
